# coding: utf-8
"""
    Superwise Main Entities

    API reference

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501
from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Optional

from pydantic import BaseModel
from pydantic import constr
from pydantic import Field

from superwise_api.client.models.model_id import ModelId
from superwise_api.client.models.prompt import Prompt


class ApplicationCreate(BaseModel):
    """
    ApplicationCreate
    """

    name: constr(strict=True, max_length=95, min_length=1) = Field(...)
    model_id: Optional[ModelId] = None
    prompt: Optional[Prompt] = None
    __properties = ["name", "model_id", "prompt"]

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ApplicationCreate:
        """Create an instance of ApplicationCreate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of model_id
        if self.model_id:
            _dict["model_id"] = self.model_id.to_dict()
        # override the default output from pydantic by calling `to_dict()` of prompt
        if self.prompt:
            _dict["prompt"] = self.prompt.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ApplicationCreate:
        """Create an instance of ApplicationCreate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ApplicationCreate.parse_obj(obj)

        _obj = ApplicationCreate.parse_obj(
            {
                "name": obj.get("name"),
                "model_id": ModelId.from_dict(obj.get("model_id")) if obj.get("model_id") is not None else None,
                "prompt": Prompt.from_dict(obj.get("prompt")) if obj.get("prompt") is not None else None,
            }
        )
        return _obj
