# coding: utf-8
"""
    Superwise Main Entities

    API reference

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501
from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Optional

from pydantic import BaseModel
from pydantic import Field
from pydantic import StrictStr

from superwise_api.client.models.ingest_type import IngestType
from superwise_api.client.models.source import Source


class DatasetSourceResponseWithSource(BaseModel):
    """
    DatasetSourceResponseWithSource
    """

    id: StrictStr = Field(...)
    source_id: StrictStr = Field(...)
    internal_dataset_id: StrictStr = Field(...)
    folder: Optional[StrictStr] = None
    query: Optional[StrictStr] = None
    created_at: Optional[datetime] = None
    updated_at: Optional[datetime] = None
    created_by: StrictStr = Field(...)
    ingest_type: Optional[IngestType] = None
    source: Source = Field(...)
    __properties = [
        "id",
        "source_id",
        "internal_dataset_id",
        "folder",
        "query",
        "created_at",
        "updated_at",
        "created_by",
        "ingest_type",
        "source",
    ]

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DatasetSourceResponseWithSource:
        """Create an instance of DatasetSourceResponseWithSource from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of source
        if self.source:
            _dict["source"] = self.source.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DatasetSourceResponseWithSource:
        """Create an instance of DatasetSourceResponseWithSource from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DatasetSourceResponseWithSource.parse_obj(obj)

        _obj = DatasetSourceResponseWithSource.parse_obj(
            {
                "id": obj.get("id"),
                "source_id": obj.get("source_id"),
                "internal_dataset_id": obj.get("internal_dataset_id"),
                "folder": obj.get("folder"),
                "query": obj.get("query"),
                "created_at": obj.get("created_at"),
                "updated_at": obj.get("updated_at"),
                "created_by": obj.get("created_by"),
                "ingest_type": obj.get("ingest_type"),
                "source": Source.from_dict(obj.get("source")) if obj.get("source") is not None else None,
            }
        )
        return _obj
